from openerp.osv import fields, osv
from string import *
from datetime import *
import datetime
import time
DEFAULT_SERVER_DATE_FORMAT = "%Y-%m-%d"

def str_to_date(str):
    """
    Converts a string to a date object using OpenERP's
    date string format (exemple: '2011-12-01').
    """
    if not str:
        return str
    return datetime.datetime.strptime(str, DEFAULT_SERVER_DATE_FORMAT).date()
  
  
class project_work(osv.osv):
    """ Inherits task.work and adds more fields"""
  
    _inherit = 'project.task.work'
    _rec_name = 'name'
      
    
    def _default_timeCard(self, cr, uid, time_id, context=None):
      print "inside _default_timeCard"
      cr.execute("SELECT max(id) FROM hr_timecard")
      result = cr.fetchall()
      temp_id = 0
      for res in result:
	print "inside for loop"
	temp_id = res[0]
	#temp_id += 1
	print temp_id
      return temp_id
      
    _columns = {
      'job_no': fields.many2one('project.project', 'Job No'),
      #'job_no': fields.related('job_no', string='Job No'),
      'overtime_hours': fields.float('Overtime Hours'), 
      'unattended_hours': fields.float('Unattended Hours'), 
      'timecard_id': fields.many2one('hr.timecard', 'Timecard', ondelete='cascade', required=True, select="1"),      
      
    }
    
    _defaults = {
      'overtime_hours': 0,
      'unattended_hours': 0,
      'timecard_id': _default_timeCard,
      }   
    
    

class legacy_projects(osv.osv):

  _inherit = "project.project"
  _rec_name = 'job_no'
  
  # Compute: effective_hours, total_hours, progress
  def _hours_get(self, cr, uid, ids, fields, arg, context=None):
      res = {}
      #vals = {}
      print "Calling get hours"
      records = self.browse(cr, uid, ids)
      for id in ids:
	for rec in records:
	  print rec.job_no
	  #print rec.otherfield
	  print "Calling get hours inside if"
	  cr.execute("SELECT COALESCE(SUM(hours + unattended_hours + overtime_hours),0) as hours FROM project_task_work WHERE job_no =(select id from project_project where job_no = '%s')"%(str(rec.job_no)))
	  sql_res = cr.fetchone()  
	  if sql_res: #The employee has one associated contract
	    print sql_res[0]
	    #vals['worked_hours'] = sql_res[0]
	    res[id] = sql_res[0]
	    
	  else:
	      #res[i] must be set to False and not to None because of XML:RPC
	      # "cannot marshal None unless allow_none is enabled"
	    res[id] = sql_res[0]
        
      print res
      return res
      
  _columns = {
    
    'job_no': fields.char('Job No', size=15, required=True),
    'quote_no': fields.char('Quote No', size=15),
    'order_no':fields.char('Order No', size=30),
    'worked_hours': fields.function(_hours_get, method=True, string='Hours Spent', help="Computed using the sum of the task work done.",
            ),
    'task_work_ids': fields.one2many('project.task.work', 'job_no', 'Worked Hours'),
  }
  
  def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
    if context is None:
      context = {}
    if context.get('job_no'):
      print "Context=======" 
      print context['job_no']
    return super(legacy_projects, self).search(cr, user, args, offset, limit, order, context=context, count=count)
    
  _sql_constraints = [('unique_name', 'unique(job_no)', 'Job no must be unique.')]


legacy_projects();



class task(osv.osv):

  _inherit = "project.task"

 # _rec_name = 'job_no'
  
  def _default_JobNo(self, cr, uid, context=None):
      proj_id =  (self._get_default_project_id(cr, uid, context))
      if proj_id:
	cr.execute("""
		  SELECT job_no
		  FROM project_project
		  WHERE id= %s
		  """, (proj_id,))
	res = cr.fetchone()
	if res:
	    #result.append(res[0])
	    print "<===============printing from results============>"
	    print type(res)
	    print res[0]
	return res[0] or False
      else:
	return False
    
    #def _get_default_project_id(self, cr, uid, context=None):
    
  #def _get_default_project_id(self, cr, uid, context=None):
      #""" Gives default section by checking if present in the context """
      #return super(project_task, self)._get_default_project_id(cr, uid, context)
      ##return (self._resolve_project_id_from_context(cr, uid, context=context) or False)

  _columns = {
    
    'job_no': fields.char('Job No', size=15),
    'quantity': fields.char('Quantity', size=5),
    'details': fields.html('Details'),
    'process_id':fields.many2one('work.process', 'Processe'),


  }
  _defaults = {
    'job_no': _default_JobNo,
    }
	  
#legacy_projectsTasks();

 
  
class res_partner(osv.osv):
    
    """ Inherits partner and adds Tasks information in the partner form """
    _inherit = 'res.partner'
    _columns = {
        'businesscard': fields.binary('Image'),
    }
    
    
    

    
  
class hr_timecard(osv.osv):
    _name = "hr.timecard"
    _order = "name DESC"
    
    
    # Compute: effective_hours, total_hours, progress
    def _hours_get(self, cr, uid, ids, field_names, args, context=None):
        res = {}
        cr.execute("SELECT task_id, COALESCE(SUM(hours),0) FROM project_task_work WHERE task_id IN %s GROUP BY task_id",(tuple(ids),))
        hours = dict(cr.fetchall())
        for task in self.browse(cr, uid, ids, context=context):
            res[task.id] = {'effective_hours': hours.get(task.id, 0.0), 'total_hours': (task.remaining_hours or 0.0) + hours.get(task.id, 0.0)}
            res[task.id]['delay_hours'] = res[task.id]['total_hours'] - task.planned_hours
            res[task.id]['progress'] = 0.0
            if (task.remaining_hours + hours.get(task.id, 0.0)):
                res[task.id]['progress'] = round(min(100.0 * hours.get(task.id, 0.0) / res[task.id]['total_hours'], 99.99),2)
            # TDE CHECK: if task.state in ('done','cancelled'):
            if task.stage_id and task.stage_id.fold:
                res[task.id]['progress'] = 100.0
        return res
      
    def _get_WeekNo(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        for name in self.browse(cr, uid, ids, context):
	    print name
	    #res[]
            #res[tasks.id] = len(tasks.task_ids)
        return res
      
  
    _columns = {
        
        'name': fields.date('Worked Date', select="1"),
        'time_in': fields.selection((('7:30', '7:30'), ('0:00', '0:00'), ('0:30', '0:30'), ('1:00', '1:00'),('1:30', '1:30'), ('2:00', '2:00'),
				     ('2:30', '2:30'), ('3:00', '3:00'),('3:30', '3:30'), ('4:00', '4:00'),
				     ('4:30', '4:30'), ('5:00', '5:00'),('5:30', '5:30'), ('6:00', '6:00'),('6:30', '6:30'),('7:00','7:00'),
				      ('8:00', '8:00'),('8:30', '8:30'), ('9:00', '9:00'), 
				     ('9:30', '9:30'), ('10:00', '10:00'), ('10:30', '10:30'), ('11:00', '11:00'),
				     ('11:30', '11:30'), ('12:00', '12:00'), ('12:30', '12:30'), ('13:00', '13:00'),
				     ('13:30', '13:30'), ('14:00', '14:00'), ('14:30', '14:30'), ('15:00', '15:00'),
				     ('15:30', '15:30'), ('16:00', '16:00'), ('16:30', '16:30'), ('17:00', '17:00'),
				     ('17:30', '17:30'), ('18:00', '18:00'), ('18:30', '18:30'), ('19:00', '19:00'),
				     ('19:30', '19:30'), ('20:00', '20:00'), ('20:30', '20:30'), ('21:00', '21:00'),
				     ('21:30', '21:30'), ('22:00', '22:00'), ('22:30', '22:30'), ('23:00', '23:00'),
				     ('23:30', '23:30'), ), 'Time In' , required=True),
	'time_out': fields.selection((('16:30', '16:30'), ('0:00', '0:00'), ('0:30', '0:30'), ('1:00', '1:00'),('1:30', '1:30'), ('2:00', '2:00'),
				     ('2:30', '2:30'), ('3:00', '3:00'),('3:30', '3:30'), ('4:00', '4:00'),
				     ('4:30', '4:30'), ('5:00', '5:00'),('5:30', '5:30'), ('6:00', '6:00'),('6:30', '6:30'),('7:00','7:00'),
				      ('7:30', '7:30'), ('8:00', '8:00'),('8:30', '8:30'), ('9:00', '9:00'), 
				     ('9:30', '9:30'), ('10:00', '10:00'), ('10:30', '10:30'), ('11:00', '11:00'),
				     ('11:30', '11:30'), ('12:00', '12:00'), ('12:30', '12:30'), ('13:00', '13:00'),
				     ('13:30', '13:30'), ('14:00', '14:00'), ('14:30', '14:30'), ('15:00', '15:00'),
				     ('15:30', '15:30'), ('16:00', '16:00'), ('17:00', '17:00'),
				     ('17:30', '17:30'), ('18:00', '18:00'), ('18:30', '18:30'), ('19:00', '19:00'),
				     ('19:30', '19:30'), ('20:00', '20:00'), ('20:30', '20:30'), ('21:00', '21:00'),
				     ('21:30', '21:30'), ('22:00', '22:00'), ('22:30', '22:30'), ('23:00', '23:00'),
				     ('23:30', '23:30'), ), 'Time Out', required=True),
        'nolunchbreak':fields.boolean('No Lunch Break'),
        'user_id': fields.many2one('res.users', 'Done by', required=True, select="1"),
        'worked_hours': fields.float('Total Hours', help='Total hours  calculated from timesheet.'),
        'work_ids': fields.one2many('project.task.work', 'timecard_id', 'Work done'),
        'week_no':fields.char('Week No', size=3),
       #'week_no': fields.function( _get_WeekNo, type='integer', string="Week No",),
        'dataentered':fields.boolean('Data Entered'),
        'image': fields.binary('Data'),
    }
	
	
    # onchange handler
    #@api.onchange('time_in', 'time_out', 'lunchbreak')
    def onchange_time(self, cr, uid, ids, in_time, out_time, nolunchbreak, context=None):
	# set auto-changing field
	print "Printing context"
	print context
        inTime = in_time
        outTime = out_time
#        #splits time input into usable chunks
        if not len(inTime) == 0 and not len(outTime) == 0 :
	  if ((":" in inTime)  or  ("." in inTime)or ("," in inTime)):
	      inTime = inTime.replace(",", ":")
	      inTime = inTime.replace(".", ":")
	  else:
	      inTime = ":".join((inTime, "00"))
	  if ((":" in outTime)  or  ("." in outTime)or ("," in outTime)):
	      outTime = outTime.replace(",", ":")
	      outTime = outTime.replace(".", ":")
	  else:
	      outTime = ":".join((outTime, "00"))
	  if inTime.endswith(":"):
	      inTime = "".join((inTime, "00"))
	  if outTime.endswith(":"):
	      outTime = "".join((outTime, "00"))
	  startSplit = split(inTime, ":")
	  endSplit = split(outTime, ":")
	  #converts strings to usable integers
	  sh = int(startSplit[0])
	  sm = int(startSplit[1])
	  eh = int(endSplit[0])
	  em = int(endSplit[1])
	  #in time format
	  smin = sh * 60 + sm
	  emin = eh * 60 + em
	  # Delta time in  minutes
	  dmin = emin - smin
	  if dmin < 0: dmin += 1440  # Wrapped around midnight?
	  if  not nolunchbreak :
	      dmin -= 30
	  # Delta time in hours
	  dtime = dmin / 60.
	  #print dtime # 5.5 hours from minutes 780->1050 (12:30-18:00).
	  val = {
	    'worked_hours':dtime
	  }
	  #print "Total worked hours is \n" 
	  #print  dtime
	  return {'value': val}
        else:
	  raise osv.except_osv('Invalid fields', 'Please enter a valid time')
	
    def onchange_date(self, cr, uid, ids, date, context=None):
        if context == None:
	  context = {}
        now = datetime.datetime.now() 
        d = datetime.datetime.strptime( date, "%Y-%m-%d" )
        date_date = str_to_date(date)
       # dd_d = datetime.datetime.strptime( date, "%Y,%m,%d" )
        print "Printing date"
        print date
        startSplit = split(date, "-")
        day = int(startSplit[2])
        month = int(startSplit[1])
        year = int(startSplit[0])
        testdate=datetime.datetime(year,month,day)
	print ((testdate - datetime.datetime(testdate.year,1,1)).days / 7) + 1
	weekno = ((testdate - datetime.datetime(testdate.year,1,1)).days / 7) + 1
	print "Week no is:"
	print weekno
	#return weekno
        #weekno = datetime.datetime.strptime( date, "%U" )
        end = d or False
        if end :
	  if end > now:
	    raise osv.except_osv('Invalid date', 'Please enter a valid date')
	isData = self._check_data(cr=cr, uid=uid, date=date)
	#print isData
	if isData:
	  raise osv.except_osv('Invalid date', 'There is data already entered in the database')
	else:
	  val = {
	    'week_no':weekno
	  }
	return {'value': val}
    
    
    def _check_data(self, cr, uid, date):
	#print "inside _check_data"
	cr.execute("SELECT  name FROM hr_timecard WHERE name=%s AND user_id=%s",(date, uid) )
	result = cr.fetchall()
	data = False
	for res in result:
	  #print "inside for loop"
	  file_name = res[0]
	  if (file_name):
	   # print "Data is true"
	    data = True
	  else: 
	   # print "Data is false"
	    data =  False
	return data
	  
    
    
    def _check_dates(self, cr, uid, ids, context=None):
      if context == None:
	context = {}
        now = datetime.datetime.now() 
       # start = obj_task.date_start or False
        end = date or False
        if end :
	  if end > now:
	    return False
        return True
   
    #def _get_WeekNo(self, cr, uid, vals, context=None):
	#testdate=datetime.datetime(2014,10,29)
	#print ((testdate - datetime.datetime(testdate.year,1,1)).days / 7) + 1
	#weekno = ((testdate - datetime.datetime(testdate.year,1,1)).days / 7) + 1
	#return weekno
	
    
      
    #def get_image(self, value ):
        #""" genrating image for graph """
        #try:
            #ret_val = createBarcodeDrawing(code, value=str(value), **options)
        #except Exception, e:
            #raise osv.except_osv('Error', e)
            
        #return base64.encodestring(ret_val.asString('jpg'))
    
    #def generate_image(self, cr, uid, ids, context=None):
        #"button function for genrating image """
        #if not context:
            #context = {}

        #for self_obj in self.browse(cr, uid, ids, context=context):
            #image = self.get_image(self_obj.code,
                        #code=self_obj.barcode_type or 'qrcode',
                        #width=self_obj.width, hight=self_obj.hight,
                        #hr=self_obj.hr_form)
            #self.write(cr, uid, self_obj.id,
                #{'image':image},context=context)
        #return True

    _defaults = {
	'worked_hours':8.00,
	'nolunchbreak':False,
        'user_id': lambda obj, cr, uid, context: uid,
        'name': fields.date.context_today,
        'time_in': '7:30',
        'time_out': '16:00',
	'dataentered':False,
        'image':'static/src/img/graph.png',
    }
    
    _constraints = [
        (_check_dates, 'Error ! You can not enter data for days you have not worked yet', ['date_start','date_end'])
    ]

class project_work_process(osv.osv):
    """ Inherits task.work and adds more fields"""
  
    _name = 'work.process'

    _columns = {
      
      'name': fields.char('Process',size=50, select="1", required = True,)	

    }
    

class smeclient_work(osv.osv):
  _name = 'smeclient.work'
  
  _columns = {
    #'name': fields.char()
    'name':fields.char('Job No', size=8, required = True,  select="1"),
    'task':fields.char('Task', size=100, required = True),
    'work_summary': fields.text('Work Summary', required = True),
    'worked_hours':fields.float('Worked Hours'),
    'overtime_hours':fields.float('Overtime Hours'),
    'unattended_hours':fields.float('Unatteded Hours'),
    'date': fields.date('Worked Date', select="1"),
    'user_id': fields.many2one('res.users', 'Done by', required=True, select="1"),
    'workid': fields.integer('Work Id'),
  }
  
  _defaults = {
        'user_id': lambda obj, cr, uid, context: uid,
        #'name': fields.date.context_today,
        
        }