from distutils.core import setup
import py2exe
import glob
import sys
import os
from distutils.filelist import findall
import matplotlib
matplotlib.use('qt5agg')
matplotlibdatadir = matplotlib.get_data_path()
matplotlibdata = findall(matplotlibdatadir)
matplotlibdata_files = []
for f in matplotlibdata:
    dirname = os.path.join('matplotlibdata', f[len(matplotlibdatadir)+1:])
    matplotlibdata_files.append((os.path.split(dirname)[0], [f]))

#sys.path.insert(0, os.path.join(sys.prefix, "PyOpenGL-3.0.0b2-py2.5.egg"))

#import pkg_resources as p
# use an Environment object with a custom search path
#env = p.Environment(['.','modules','plugins'])
# for dists in env:
    # pkgs = env[dists]
    # # only activate the newest distribution available
    # dist = pkgs.pop(0)
    # print "activating ", dist
    # dist.activate()
    
    
def tree(src):
    list = [(root, map(lambda f: os.path.join(root, f), files)) for (root, dirs, files) in os.walk(os.path.normpath(src))]
    new_list = []
    for (root, files) in list:
        if len(files) > 0 and root.count('.svn') == 0:
            new_list.append((root, files))
    return new_list 


options = {'py2exe':{'excludes':['OpenGL','backend_gtkagg', 'backend_wxagg'],
                    'packages':['logging','matplotlib',  'pytz'],
                    'dll_excludes': ['libgdk_pixbuf-2.0-0.dll', 'libgobject-2.0-0.dll', 'libgdk-win32-2.0-0.dll'],
                    'includes':['distutils.util', 'sip', 'matplotlib.backends.backend_qt5agg', 'PyQt5',  'PyQt5.QtPrintSupport']}}

xdata_files=[ ('sqldrivers', glob.glob('sqldrivers/*.*' )),
                        'user.png'
                    ]
#matplotlib_data_files = tree('mpl-data')
image_data =[('images', glob.glob('images/*.*' ))]
setup(
	name = "SMETime", 
	version="2.1.0",
	windows=[{"script":"SMEClient.py","icon_resources": [(0, "lighttasks.ico")]}],
	options=options,
	)

#setup (
#        package_dir = {'test':'.'},
#        scripts = [ 'MyApp.py' ],
#        options={"py2exe" : {"includes" : ["sip", "PyQt4._qt"]}}
