###################################################################################
# -*- coding: utf-8 -*-                                                           #
#!/usr/bin/env python                                                             #
# SMETime Data Manager for SME's                                                  #
# Copyright (C) 2008 Anil anilet@gmail.com                                        #
#                                                                                 #
# This program is free software; you can redistribute it and/or                   #
# modify it under the terms of the GNU General Public License                     #
# version 2 as published by the Free Software Foundation.                         #
#                                                                                 #
# This program is distributed in the hope that it will be useful,                 #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   #
# GNU General Public License for more details.                                    #
#                                                                                 #
# You should have received a copy of the GNU General Public License               #
# along with this program; if not, write to the Free Software                     #
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. #
###################################################################################




import matplotlib
matplotlib.use("Qt5Agg")
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import  QWidget
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.figure import Figure
import matplotlib.pyplot as mpl

from pylab import *
from PyQt5.QtSql import *


class MyMplCanvas(FigureCanvas):
    def __init__(self, parent=None, width = 2, height = 4, dpi = 100,sharex = None, sharey = None):
        self.figure = Figure(figsize = (width, height), dpi=dpi, facecolor = 'none', edgecolor = 'none')
        
        mpl.rcParams['xtick.minor.size'] = 3
        mpl.rcParams['ytick.labelsize'] =6
        mpl.rcParams['xtick.labelsize'] =6 
        
        #minorLocator = MultipleLocator(1.0)
        #minorFormattor = FormatStrFormatter('%0.1f')
        
        self.axis = self.figure.add_subplot(111)
        self.figure.subplots_adjust(left=0.03, bottom=0.05, right=0.99, top=0.98)
#        self.axis.set_xlabel('Date')   
#        self.axis.set_ylabel('Hours')   
#        self.axis.set_title('Hours Graph')   
        self.axis.grid(True)  
    
    #mpl.
        self.axis.axis([0, 31, 0, 15])
        FigureCanvas.__init__(self, self.figure)
#self.fc = FigureCanvas(self.fig)
        FigureCanvas.setSizePolicy(self,QtWidgets.QSizePolicy.Expanding,QtWidgets.QSizePolicy.Expanding)
        FigureCanvas.updateGeometry(self)
       #FigureCanvas.set_facecolor('red') 
        self.mpl_connect('pick_event', self.on_pick)

    def format_labels(self):
        self.axis.set_title(self.PlotTitle)
        self.axis.title.set_fontsize(8)
        self.axis.set_xlabel(self.xtitle, fontsize = 8)
        self.axis.set_ylabel(self.ytitle, fontsize = 8)
        labels_x = self.axis.get_xticklabels()
        labels_y = self.axis.get_yticklabels()

        for xlabel in labels_x:
            xlabel.set_fontsize(6)
        for ylabel in labels_y:
            ylabel.set_fontsize(6)
            ylabel.set_color('b')

    def sizeHint(self):
        w, h = self.get_width_height()
        return QtCore.QSize(w, h)

    def minimumSizeHint(self):
        return QtCore.QSize(8, 8)


    def on_pick(self, event):
        box_points = event.artist.get_bbox().get_points()
        msg = "You've clicked on a bar with coords:\n %s" % box_points
        return msg



class MPL_pyqt4_widget(QWidget):
    def __init__(self, parent = None):
        QWidget.__init__(self, parent)
        self.canvas = MyMplCanvas()
        #self.toolbar = NavigationToolbar(self.canvas, self.canvas)
        self.vbox = QtWidgets.QVBoxLayout()
        self.vbox.addWidget(self.canvas)
        #self.vbox.addWidget(self.toolbar)
        self.setLayout(self.vbox)

