###################################################################################
# -*- coding: utf-8 -*-                                                           #
#!/usr/bin/env python                                                             #
# SMETime Data Manager for SME's                                                  #
# Copyright (C) 2008 Anil anilet@gmail.com                                        #
#                                                                                 #
# This program is free software; you can redistribute it and/or                   #
# modify it under the terms of the GNU General Public License                     #
# version 2 as published by the Free Software Foundation.                         #
#                                                                                 #
# This program is distributed in the hope that it will be useful,                 #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                  #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                   #
# GNU General Public License for more details.                                    #
#                                                                                 #
# You should have received a copy of the GNU General Public License               #
# along with this program; if not, write to the Free Software                     #
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. #
###################################################################################


from PyQt5.QtCore import *
from PyQt5.QtGui import *



 
class Property(QFrame):

    def __init__(self, parent=None):
        super(Property, self).__init__(parent)
        self.myfont = QFont(self)
        self.myfont.setFamily("Nimbus Sans L")
        self.myfont.setPixelSize ( 11 )
        self.myfont.setBold(True)
    
    
    def paintEvent(self, event=None):
        painter = QPainter(self)
       # painter.begin(self)
        painter.setPen(QColor(49,43,35,200))
        painter.setRenderHint(QPainter.Antialiasing)
        gradient = QRadialGradient( -100, -100, self.width(),0,0 )
        gradient.setColorAt(0.0, QColor(129,123,115,150))
        gradient.setColorAt(1.0, QColor(129,123,115,0))
        painter.setBrush(QBrush(gradient))
        painter.drawRoundedRect(1, 1, self.width()-2, self.height()-2,8,8,Qt.AbsoluteSize)

        gradient = QLinearGradient(0.0,0.0,0.0,self.height())
        gradient.setColorAt(0.0, QColor(244,244,241))
        gradient.setColorAt(0.3, QColor(244,244,241))
        gradient.setColorAt(1.0, QColor(200,200,180))
        gradient.setColorAt(1.0, QColor(153,153,153))
        painter.drawRoundedRect(6, 36, self.width()-12, self.height()-42,7,7,Qt.AbsoluteSize)
        painter.setFont(self.myfont)
        painter.setPen(QColor(189,183,175))
        painter.drawText(QRect(10,0,self.width()-20,36), Qt.AlignCenter,self.statusTip())

       
